/*
######################################################################
# xs_split.c - This is PyukiWiki yet another Wiki clone
# $Id: xs_split.c,v 1.83 2013/03/09 02:12:34 papu Exp $
# Build 2013-03-08 11:49:13
#
#
# Author Nanami
# http://nanakochi.daiba.cx/
# Copyright(C) 2004-2007 Nekyo
# Copyright(C) 2005-2013 PyukiWiki Developers Team
# http://pyukiwiki.info/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sfjp.jp/
# License GPL3 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return=CRLF Code=EUC-JP 1TAB=4Spaces
######################################################################
*/

#include "xslib.h"

char	*xs_split(char *buf, char *split, char *src, int n) {
	char	*pt;
	int		i;

	strcpy(buf, src);

	pt = strtok(buf, split);
	if(pt == NULL) {
		return src;
	}
	if(n == 0) {
		return pt;
	}

	for(i = 1; (pt = strtok(NULL, split)) != NULL && i < n; i++);

	return pt;
}
